diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/post.php ./wordpress-3.3/wp-admin/includes/post.php
*** ./wordpress-3.2.1/wp-admin/includes/post.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/post.php	2011-11-24 10:06:17.000000000 -0600
***************
*** 191,206 ****
  	}
  
  	// Post Formats
! 	if ( current_theme_supports( 'post-formats' ) && isset( $post_data['post_format'] ) ) {
! 		$formats = get_theme_support( 'post-formats' );
! 		if ( is_array( $formats ) ) {
! 			$formats = $formats[0];
! 			if ( in_array( $post_data['post_format'], $formats ) ) {
! 				set_post_format( $post_ID, $post_data['post_format'] );
! 			} elseif ( '0' == $post_data['post_format'] ) {
! 				set_post_format( $post_ID, false );
! 			}
! 		}
  	}
  
  	// Meta Stuff
--- 191,201 ----
  	}
  
  	// Post Formats
! 	if ( isset( $post_data['post_format'] ) ) {
! 		if ( current_theme_supports( 'post-formats', $post_data['post_format'] ) )
! 			set_post_format( $post_ID, $post_data['post_format'] );
! 		elseif ( '0' == $post_data['post_format'] )
! 			set_post_format( $post_ID, false );
  	}
  
  	// Meta Stuff
***************
*** 210,216 ****
  				continue;
  			if ( $meta->post_id != $post_ID )
  				continue;
! 			if ( is_protected_meta( $value['key'] ) )
  				continue;
  			update_meta( $key, $value['key'], $value['value'] );
  		}
--- 205,211 ----
  				continue;
  			if ( $meta->post_id != $post_ID )
  				continue;
! 			if ( is_protected_meta( $value['key'], 'post' ) || ! current_user_can( 'edit_post_meta', $post_ID, $value['key'] ) )
  				continue;
  			update_meta( $key, $value['key'], $value['value'] );
  		}
***************
*** 222,228 ****
  				continue;
  			if ( $meta->post_id != $post_ID )
  				continue;
! 			if ( is_protected_meta( $meta->meta_key ) )
  				continue;
  			delete_meta( $key );
  		}
--- 217,223 ----
  				continue;
  			if ( $meta->post_id != $post_ID )
  				continue;
! 			if ( is_protected_meta( $meta->meta_key, 'post' ) || ! current_user_can( 'delete_post_meta', $post_ID, $meta->meta_key ) )
  				continue;
  			delete_meta( $key );
  		}
***************
*** 234,249 ****
  
  	wp_update_post( $post_data );
  
- 	// Reunite any orphaned attachments with their parent
- 	if ( !$draft_ids = get_user_option( 'autosave_draft_ids' ) )
- 		$draft_ids = array();
- 	if ( $draft_temp_id = (int) array_search( $post_ID, $draft_ids ) )
- 		_relocate_children( $draft_temp_id, $post_ID );
- 
  	// Now that we have an ID we can fix any attachment anchor hrefs
  	_fix_attachment_links( $post_ID );
  
! 	wp_set_post_lock( $post_ID, $GLOBALS['current_user']->ID );
  
  	if ( current_user_can( $ptype->cap->edit_others_posts ) ) {
  		if ( ! empty( $post_data['sticky'] ) )
--- 229,238 ----
  
  	wp_update_post( $post_data );
  
  	// Now that we have an ID we can fix any attachment anchor hrefs
  	_fix_attachment_links( $post_ID );
  
! 	wp_set_post_lock( $post_ID );
  
  	if ( current_user_can( $ptype->cap->edit_others_posts ) ) {
  		if ( ! empty( $post_data['sticky'] ) )
***************
*** 312,320 ****
  		foreach ( $post_data['tax_input'] as $tax_name => $terms ) {
  			if ( empty($terms) )
  				continue;
! 			if ( is_taxonomy_hierarchical( $tax_name ) )
  				$tax_input[$tax_name] = array_map( 'absint', $terms );
! 			else {
  				$tax_input[$tax_name] = preg_replace( '/\s*,\s*/', ',', rtrim( trim($terms), ' ,' ) );
  				$tax_input[$tax_name] = explode(',', $tax_input[$tax_name]);
  			}
--- 301,309 ----
  		foreach ( $post_data['tax_input'] as $tax_name => $terms ) {
  			if ( empty($terms) )
  				continue;
! 			if ( is_taxonomy_hierarchical( $tax_name ) ) {
  				$tax_input[$tax_name] = array_map( 'absint', $terms );
! 			} else {
  				$tax_input[$tax_name] = preg_replace( '/\s*,\s*/', ',', rtrim( trim($terms), ' ,' ) );
  				$tax_input[$tax_name] = explode(',', $tax_input[$tax_name]);
  			}
***************
*** 337,342 ****
--- 326,339 ----
  		}
  	}
  
+ 	if ( isset( $post_data['post_format'] ) ) {
+ 		if ( '0' == $post_data['post_format'] )
+ 			$post_data['post_format'] = false;
+ 		// don't change the post format if it's not supported or not '0' (standard)
+ 		elseif ( ! current_theme_supports( 'post-formats', $post_data['post_format'] ) )
+ 			unset( $post_data['post_format'] );
+ 	}
+ 
  	$updated = $skipped = $locked = array();
  	foreach ( $post_IDs as $post_ID ) {
  		$post_type_object = get_post_type_object( get_post_type( $post_ID ) );
***************
*** 387,392 ****
--- 384,391 ----
  				unstick_post( $post_ID );
  		}
  
+ 		if ( isset( $post_data['post_format'] ) )
+ 			set_post_format( $post_ID, $post_data['post_format'] );
  	}
  
  	return array( 'updated' => $updated, 'skipped' => $skipped, 'locked' => $locked );
***************
*** 425,430 ****
--- 424,430 ----
  		if ( current_theme_supports( 'post-formats' ) && post_type_supports( $post->post_type, 'post-formats' ) && get_option( 'default_post_format' ) )
  			set_post_format( $post, get_option( 'default_post_format' ) );
  	} else {
+ 		$post = new stdClass;
  		$post->ID = 0;
  		$post->post_author = '';
  		$post->post_date = '';
***************
*** 551,583 ****
  	// Clear out any data in internal vars.
  	unset( $_POST['filter'] );
  
- 	// Check for autosave collisions
- 	// Does this need to be updated? ~ Mark
- 	$temp_id = false;
- 	if ( isset($_POST['temp_ID']) ) {
- 		$temp_id = (int) $_POST['temp_ID'];
- 		if ( !$draft_ids = get_user_option( 'autosave_draft_ids' ) )
- 			$draft_ids = array();
- 		foreach ( $draft_ids as $temp => $real )
- 			if ( time() + $temp > 86400 ) // 1 day: $temp is equal to -1 * time( then )
- 				unset($draft_ids[$temp]);
- 
- 		if ( isset($draft_ids[$temp_id]) ) { // Edit, don't write
- 			$_POST['post_ID'] = $draft_ids[$temp_id];
- 			unset($_POST['temp_ID']);
- 			update_user_option( $user_ID, 'autosave_draft_ids', $draft_ids );
- 			return edit_post();
- 		}
- 	}
- 
  	// Edit don't write if we have a post id.
! 	if ( isset( $_POST['ID'] ) ) {
! 		$_POST['post_ID'] = $_POST['ID'];
! 		unset ( $_POST['ID'] );
! 	}
! 	if ( isset( $_POST['post_ID'] ) ) {
  		return edit_post();
- 	}
  
  	$translated = _wp_translate_postdata( false );
  	if ( is_wp_error($translated) )
--- 550,558 ----
  	// Clear out any data in internal vars.
  	unset( $_POST['filter'] );
  
  	// Edit don't write if we have a post id.
! 	if ( isset( $_POST['post_ID'] ) )
  		return edit_post();
  
  	$translated = _wp_translate_postdata( false );
  	if ( is_wp_error($translated) )
***************
*** 611,635 ****
  
  	add_post_meta( $post_ID, '_edit_last', $GLOBALS['current_user']->ID );
  
- 	// Reunite any orphaned attachments with their parent
- 	// Does this need to be udpated? ~ Mark
- 	if ( !$draft_ids = get_user_option( 'autosave_draft_ids' ) )
- 		$draft_ids = array();
- 	if ( $draft_temp_id = (int) array_search( $post_ID, $draft_ids ) )
- 		_relocate_children( $draft_temp_id, $post_ID );
- 	if ( $temp_id && $temp_id != $draft_temp_id )
- 		_relocate_children( $temp_id, $post_ID );
- 
- 	// Update autosave collision detection
- 	if ( $temp_id ) {
- 		$draft_ids[$temp_id] = $post_ID;
- 		update_user_option( $user_ID, 'autosave_draft_ids', $draft_ids );
- 	}
- 
  	// Now that we have an ID we can fix any attachment anchor hrefs
  	_fix_attachment_links( $post_ID );
  
! 	wp_set_post_lock( $post_ID, $GLOBALS['current_user']->ID );
  
  	return $post_ID;
  }
--- 586,595 ----
  
  	add_post_meta( $post_ID, '_edit_last', $GLOBALS['current_user']->ID );
  
  	// Now that we have an ID we can fix any attachment anchor hrefs
  	_fix_attachment_links( $post_ID );
  
! 	wp_set_post_lock( $post_ID );
  
  	return $post_ID;
  }
***************
*** 638,644 ****
   * Calls wp_write_post() and handles the errors.
   *
   * @since 2.0.0
!  *
   * @return unknown
   */
  function write_post() {
--- 598,607 ----
   * Calls wp_write_post() and handles the errors.
   *
   * @since 2.0.0
! 
!  * @uses wp_write_post()
!  * @uses is_wp_error()
!  * @uses wp_die()
   * @return unknown
   */
  function write_post() {
***************
*** 667,696 ****
  
  	$metakeyselect = isset($_POST['metakeyselect']) ? stripslashes( trim( $_POST['metakeyselect'] ) ) : '';
  	$metakeyinput = isset($_POST['metakeyinput']) ? stripslashes( trim( $_POST['metakeyinput'] ) ) : '';
! 	$metavalue = isset($_POST['metavalue']) ? maybe_serialize( stripslashes_deep( $_POST['metavalue'] ) ) : '';
! 	if ( is_string($metavalue) )
  		$metavalue = trim( $metavalue );
  
! 	if ( ('0' === $metavalue || !empty ( $metavalue ) ) && ((('#NONE#' != $metakeyselect) && !empty ( $metakeyselect) ) || !empty ( $metakeyinput) ) ) {
  		// We have a key/value pair. If both the select and the
  		// input for the key have data, the input takes precedence:
  
!  		if ('#NONE#' != $metakeyselect)
  			$metakey = $metakeyselect;
  
! 		if ( $metakeyinput)
  			$metakey = $metakeyinput; // default
  
! 		if ( is_protected_meta( $metakey ) )
  			return false;
  
! 		wp_cache_delete($post_ID, 'post_meta');
! 		$wpdb->insert( $wpdb->postmeta, array( 'post_id' => $post_ID, 'meta_key' => $metakey, 'meta_value' => $metavalue ) );
! 		$meta_id = $wpdb->insert_id;
! 		do_action( 'added_postmeta', $meta_id, $post_ID, $metakey, $metavalue );
  
! 		return $meta_id;
  	}
  	return false;
  } // add_meta
  
--- 630,657 ----
  
  	$metakeyselect = isset($_POST['metakeyselect']) ? stripslashes( trim( $_POST['metakeyselect'] ) ) : '';
  	$metakeyinput = isset($_POST['metakeyinput']) ? stripslashes( trim( $_POST['metakeyinput'] ) ) : '';
! 	$metavalue = isset($_POST['metavalue']) ? $_POST['metavalue'] : '';
! 	if ( is_string( $metavalue ) )
  		$metavalue = trim( $metavalue );
  
! 	if ( ('0' === $metavalue || ! empty ( $metavalue ) ) && ( ( ( '#NONE#' != $metakeyselect ) && !empty ( $metakeyselect) ) || !empty ( $metakeyinput ) ) ) {
  		// We have a key/value pair. If both the select and the
  		// input for the key have data, the input takes precedence:
  
!  		if ( '#NONE#' != $metakeyselect )
  			$metakey = $metakeyselect;
  
! 		if ( $metakeyinput )
  			$metakey = $metakeyinput; // default
  
! 		if ( is_protected_meta( $metakey, 'post' ) || ! current_user_can( 'add_post_meta', $post_ID, $metakey ) )
  			return false;
  
! 		$metakey = esc_sql( $metakey );
  
! 		return add_post_meta( $post_ID, $metakey, $metavalue );
  	}
+ 
  	return false;
  } // add_meta
  
***************
*** 703,719 ****
   * @return unknown
   */
  function delete_meta( $mid ) {
! 	global $wpdb;
! 	$mid = (int) $mid;
! 
! 	$post_id = $wpdb->get_var( $wpdb->prepare("SELECT post_id FROM $wpdb->postmeta WHERE meta_id = %d", $mid) );
! 
! 	do_action( 'delete_postmeta', $mid );
! 	wp_cache_delete($post_id, 'post_meta');
! 	$rval = $wpdb->query( $wpdb->prepare("DELETE FROM $wpdb->postmeta WHERE meta_id = %d", $mid) );
! 	do_action( 'deleted_postmeta', $mid );
! 
! 	return $rval;
  }
  
  /**
--- 664,670 ----
   * @return unknown
   */
  function delete_meta( $mid ) {
! 	return delete_metadata_by_mid( 'post' , $mid );
  }
  
  /**
***************
*** 744,758 ****
   * @return unknown
   */
  function get_post_meta_by_id( $mid ) {
! 	global $wpdb;
! 	$mid = (int) $mid;
! 
! 	$meta = $wpdb->get_row( $wpdb->prepare("SELECT * FROM $wpdb->postmeta WHERE meta_id = %d", $mid) );
! 	if ( empty($meta) )
! 		return false;
! 	if ( is_serialized_string( $meta->meta_value ) )
! 		$meta->meta_value = maybe_unserialize( $meta->meta_value );
! 	return $meta;
  }
  
  /**
--- 695,701 ----
   * @return unknown
   */
  function get_post_meta_by_id( $mid ) {
! 	return get_metadata_by_mid( 'post', $mid );
  }
  
  /**
***************
*** 785,814 ****
   * @return unknown
   */
  function update_meta( $meta_id, $meta_key, $meta_value ) {
! 	global $wpdb;
! 
! 	$meta_key = stripslashes($meta_key);
! 
! 	if ( is_protected_meta( $meta_key ) )
! 		return false;
! 
! 	if ( '' === trim( $meta_value ) )
! 		return false;
! 
! 	$post_id = $wpdb->get_var( $wpdb->prepare("SELECT post_id FROM $wpdb->postmeta WHERE meta_id = %d", $meta_id) );
! 
! 	$meta_value = maybe_serialize( stripslashes_deep( $meta_value ) );
! 	$meta_id = (int) $meta_id;
! 
! 	$data  = compact( 'meta_key', 'meta_value' );
! 	$where = compact( 'meta_id' );
  
! 	do_action( 'update_postmeta', $meta_id, $post_id, $meta_key, $meta_value );
! 	$rval = $wpdb->update( $wpdb->postmeta, $data, $where );
! 	wp_cache_delete($post_id, 'post_meta');
! 	do_action( 'updated_postmeta', $meta_id, $post_id, $meta_key, $meta_value );
! 
! 	return $rval;
  }
  
  //
--- 727,736 ----
   * @return unknown
   */
  function update_meta( $meta_id, $meta_key, $meta_value ) {
! 	$meta_key = stripslashes( $meta_key );
! 	$meta_value = stripslashes_deep( $meta_value );
  
! 	return update_metadata_by_mid( 'post', $meta_id, $meta_value, $meta_key );
  }
  
  //
***************
*** 1275,1281 ****
   * @since 2.5.0
   *
   * @param int $post_id ID of the post to being edited
!  * @return bool Returns false if the post doesn't exist of there is no current user
   */
  function wp_set_post_lock( $post_id ) {
  	if ( !$post = get_post( $post_id ) )
--- 1197,1204 ----
   * @since 2.5.0
   *
   * @param int $post_id ID of the post to being edited
!  * @return bool|array Returns false if the post doesn't exist of there is no current user, or
!  * 	an array of the lock time and the user ID.
   */
  function wp_set_post_lock( $post_id ) {
  	if ( !$post = get_post( $post_id ) )
***************
*** 1287,1292 ****
--- 1210,1216 ----
  	$lock = "$now:$user_id";
  
  	update_post_meta( $post->ID, '_edit_lock', $lock );
+ 	return array( $now, $user_id );
  }
  
  /**
***************
*** 1356,1366 ****
   * @package WordPress
   * @since 2.7.0
   *
!  * @uses wp_write_post()
   * @uses edit_post()
   * @uses get_post()
   * @uses current_user_can()
   * @uses wp_create_post_autosave()
   *
   * @return str URL to redirect to show the preview
   */
--- 1280,1293 ----
   * @package WordPress
   * @since 2.7.0
   *
!  * @uses get_post_status()
   * @uses edit_post()
   * @uses get_post()
   * @uses current_user_can()
+  * @uses wp_die()
   * @uses wp_create_post_autosave()
+  * @uses add_query_arg()
+  * @uses wp_create_nonce()
   *
   * @return str URL to redirect to show the preview
   */
